/*
 * Created on 18 ��� 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package source;//consistent.significant_percentiles;
import java.util.*;


/**
 * @author Pavlos Pavlidis
 * @version 24 Junuary 2005
 * 
 * TODO 1. It randomizes the label of the initial Dataset, creating a new
 * random dataset.
 * 2. For this dataset and for every gene, it calculates the N more 
 * consistent regions (NPvalue)
 * 3. It creates a distribution of the above regions for every N 
 * 4. It stores the maximum consistency of the region which has a consistency that
 * is observed more than 1-%percentile
 * 5. This is the threshold of this Nth region for the particular random dataset
 * 6. It makes the above steps X times and holds the maximum values
 * 7. Finally it returns a float[][] in which each row is the number of
 * classes and each column the order of the consistent region 
 *
 */


public class ComputePValues {
	private float[][] values; // training set arrays
	private int[] labels;//, tlab;
	private int p,n, label1, label2;
	//protected float[][] test; // test set array
	
	
	/**
	 * Constructor of the class. It has as arguments the path of 
	 * training file and the file of labels
	 * Note that the training file MUST NOT have in the beginning 
	 * the labels
	 */
	public ComputePValues(String TrainFile, String LabelFile){
		GetData gd=new GetData(TrainFile, LabelFile);
		values=gd.training();
		labels=gd.labels();
		label1=gd.label1();
		label2=gd.label2();
		p=gd.p();
		n=gd.n();	
	}
        //this method is deleted . No randomization from now on!
	/** 
	 * It changes randomly the labels of the initial dataset
	 * It maintains the number of each label
	 * @return the new label array
	 */
/*
        public int[] ChangeLabels(){
    	essential e=new essential();
    	int[] lab=new int[labels.length];
    	for (int i=0; i<labels.length; i++){
    		lab[i]=labels[i];
    	}
    	int prob_zero=n;
    	int prob_one=p;
    	
    	for (int i=0; i<labels.length; i++){
    		int chooser=(int)(Math.random()*(prob_zero+prob_one-1))+1;
    		if (chooser<=prob_zero){
    			lab[i]=label1;
    			prob_zero--;
    		}
    		else{
    			lab[i]=label2;
    			prob_one--;
    		}
    	}
    	p=n=0;
    	for (int i=0; i<lab.length; i++){
    		if (lab[i]==label1){
    			n++;
    		}
    		else{
    			p++;
    		}
    	}
    	return lab;
    }
 */
    
   
    
    //*********************** SECTION FOR ΜΑΝΥ CONSISTENCY REGIONS ************************
    /**
     * For this random labeled dataset, it calculates the consistency
     * of the MAXIMUM region that its consistency has a such value that its
     * probability is greater than 1-%threshold
     * @param nofreg: The number of regions that will search for every 
     * gene
     * @param pthreshold : the %threshold as described above
     * @return a float[][]. Its lines are the classes (0 or 1)
     * and the columns are the order of the consistent region
     */
    public float[][] NPvalue(int nofreg, double pthreshold){
    	
    	essential e=new essential();
    	
    	float[][] TotmaxNper=new  float[2][nofreg];
    	int[] lab=labels;
    	float[][] cl_array=e.GetSortedClassesFromArray(values,lab);
    	float[][] beans1=new float[nofreg][n+1];
    	float[][] beans2=new float[nofreg][p+1];
    	
    	for (int i=0; i<cl_array.length; i++){
    		int[][] maxNper=new int[2][nofreg];
    		for (int j=0; j<cl_array[0].length-1; j++){
    			int reg=1;
    			
    			while (j<(cl_array[0].length-1) && cl_array[i][j]==cl_array[i][j+1]){
    				reg++;
    				j++;
    			}
    			if (cl_array[i][j]==label1){
    				if (reg>maxNper[0][0]) maxNper[0][0]=reg;
    			}
    			else {
    				if (reg>maxNper[1][0]) maxNper[1][0]=reg;
    			}
    			Arrays.sort(maxNper[0]);
    			Arrays.sort(maxNper[1]);
    			
    		}
    		for (int ii=0; ii<nofreg; ii++){
    			beans1[ii][maxNper[0][ii]]++;
    			beans2[ii][maxNper[1][ii]]++;
    		}
    	}
    	int[] sum1=new int[nofreg];
    	int[] sum2=new int[nofreg];
    	
    	for (int i=0; i<nofreg; i++){
    		sum1[i]=cl_array.length;;
    		out:
    		for (int j=beans1[0].length-1; j>0; j--){
    			double pos=(double)beans1[i][j]/(double)sum1[i];
    			if(pos>(1-pthreshold)){
    				TotmaxNper[0][i]=(float)j/(float)n;
    				break out;
    			}
    		}
    	}
    	for (int i=0; i<nofreg; i++){
    		sum2[i]=cl_array.length;
    		out:
    		for (int j=beans2[0].length-1; j>0; j--){
    			double pos=(double)beans2[i][j]/(double)sum2[i];
    			if(pos>(1-pthreshold)){
    				TotmaxNper[1][i]=(float)j/(float)p;
    				break out;
    			}
    		}
    	}
    	return TotmaxNper;
    }
    
    
    /**
     * It contains a loop, that runs the method NPvalue X times
     * After that it stores the MAXIMUM value of this replication 
     * procedure, for every order of consistent regions
     * @param times : the extension of replication
     * @param nofreg : Number of consistent regions
     * @param pthreshold :the %threshold
     * @return
     */
    public float[][] ComputePercentiles(int nofreg, double pthreshold){
    	
    	essential e=new essential();
    	float[][] perc=new float[2][nofreg];// 0 h 1/ poses perioxes tha parw se kathe gonidio / epanalipseis
    	float[][] pvalue=new float[2][nofreg];
    	//for (int i=0; i<times; i++){
    	//System.out.println(i);
     	float[][] maxp=NPvalue(nofreg,pthreshold);
    	for (int ii=0; ii<nofreg; ii++){
            perc[0][ii]=maxp[0][ii];
            perc[1][ii]=maxp[1][ii];
    	}
    	for (int ii=0; ii<nofreg; ii++){
    		//Arrays.sort(perc[0][ii]);
    		//Arrays.sort(perc[1][ii]);
    		pvalue[0][ii]=perc[0][ii];
    		pvalue[1][ii]=perc[1][ii];
    	}
    	//e.PrintArray(pvalue);
    	return pvalue;
    	
    }
	/**
	 * 
	 * @return 
	 * the traning set
	 */
	public float[][] training(){
		return values;
	}
	
	public float[][] training(int exclude){
		float[][] tr=values;
		float[][] ntr=new float[tr.length][tr[0].length-1];
		if(exclude>0){
			for (int i=0; i<tr.length; i++){
				int jj=0;
				for (int j=0; j<tr[0].length; j++){
					if (j!=exclude){
						ntr[i][jj]=tr[i][j];
						jj++;
					}
				}
			}
			return ntr;
		}
		else{
			return tr;
		}
	}
	/**
	 * 
	 * @return
	 * the labels
	 */
	public int[] labels(){
		return labels;
	}
	
	public int[] labels(int exclude){
		int[] lab=labels;
		int[] nlab=new int[lab.length-1];
		if (exclude>0){
			int j=0;
			for (int i=0; i<lab.length; i++){
				if(i!=exclude){
					nlab[j]=lab[i];
					j++;
				}
			}
			return nlab;
		}
		else{
			return lab;
		}
	}
	/*
	public int[] Rand_labels(int exclude){
		int[] lab=labels;
		lab=ChangeLabels();
		int[] nlab=new int[lab.length-1];
		if (exclude>0){
			int j=0;
			for (int i=0; i<lab.length; i++){
				if(i!=exclude){
					nlab[j]=lab[i];
					j++;
				}
			}
			return nlab;
		}
		else{
			return lab;
		}
	}
         */
	
	/**
	 * 
	 * @return the number of samples that are label2
	 */
	public int p(){
		return p;
	}
	/**
	 * 
	 * @return the number of samples that are label1
	 */
	public int n(){
		return n;
	}
	/**
	 * 
	 * @return label1
	 */
	public int label1(){
		return label1;
	}
	/**
	 * 
	 * @return label2
	 */
	public int label2(){
		return label2;
	}

}
