/*
 * Created on 24 Jan 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package source;//consistent.significant_percentiles;

import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Vector;
import java.util.*;

/**
 * @author Administrator
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ConsistentRegions {
    private float[][] train,test;
    private int[] labels;
    private float[][] pvalues;
    private int p,n,label1,label2;
    public int[] classification1; int[] classification2;
    
    private double similarity=0;
    private double difference=0;
    
    /**
     * The Constructor of the class.
     * @param TrainFile, the file with the training set
     * @param LabelFile, the file with the label set
     * @param TestFile, the file with the test set
     * @param nofreg, the maximum number of regions that   you require to be found from the program
     * @param nofrepl, the number of iterations for the computation of p
     * @param percent, the percentage value. It is used in the determination of the consistent regions
     * @param exclude. this parameter is used in LOOCV. It excludes a particular sample from the training set
     */
    public ConsistentRegions(String TrainFile, String LabelFile, String TestFile,int nofreg, double percent, int exclude){
        
        essential e=new essential();
        GetData gd=new GetData(TestFile);
        ComputePValues cp=new ComputePValues(TrainFile, LabelFile);
        train=cp.training(exclude);
        
        labels=cp.labels(exclude);
        //labels=cp.Rand_labels(exclude);
        //tlab=cp.labels();
        label1=cp.label1();
        label2=cp.label2();
        p=cp.p();
        n=cp.n();
        pvalues=cp.ComputePercentiles(nofreg,percent);
        
        System.out.println();
        System.out.println("Pvalues are:  (Max Order -> Min Order)");
        e.PrintArray(pvalues);
        
        //test=e.MergeArrays(gd.test(),train);
        //test=e.MergeArrays(gd.test(),gd.GetMeanTrain(train,labels,n,p)); // enwsi test set me ta main tou training set
        test=gd.test(); //kanoniko test set
        //train=e.MergeArrays(gd.training(),gd.test()); // enwsi training me test set
        //  System.out.println("@@@@@@@@@@@@@@@@@@ CLASSES @@@@@@@@@@@@@@@");
        //e.GetSortedClassesFromArray(train,labels);
        // System.out.println("********************** INDEXES *****************");
        //e.GetSortedIndexesFromArray(test);
        // System.out.println("############### VALUES #######################");
        // e.GetSortedValuesFromArray(train);
        
    }
    
    /**
     * Another constructor of the class
     *
     */
    public ConsistentRegions(){
        
    }
    
    
    /**
     *
     * @param cat
     * @return
     */
    public float[][] CatClassifiers(int cat) {
        essential e=new essential();
        float[][] consistentmatrix;
        float[][] cl=e.GetSortedClassesFromArray(train,labels); // cl = array with class values sorted according to the expression values
        float[][] val=e.GetSortedValuesFromArray(train); // array with sorted lines
        Vector v=new Vector();
        
        for (int i=0; i<cl.length; i++){
            int succ1=0, succ2=0;
            for (int j=0; j<cl[0].length; j++){ // here starts the scanning of each line for consisteent regions
                
                int reg=1;
                while(j+1<cl[0].length && cl[i][j]==cl[i][j+1]){
                    reg++; // the length of the consistent region
                    j++;
                }
                float perc1=0;
                float perc2=0;
                if (cl[i][j]==label1){
                    perc1=(float)reg/(float)n; //  the percentage of consistency of the region with labels from the first class
                } else {
                    perc2=(float)reg/(float)p; // the percentage of consistency of the region with labels from the second class
                }
                float perc=Math.max(perc1,perc2);
                if(perc1>pvalues[0][pvalues[0].length-cat]){ // a test for the region, if its consistency is greater than the statistical correspondig p value
                    succ1++;
                }
                if(perc2>pvalues[1][pvalues[0].length-cat]){
                    succ2++;
                }
            }
            if (succ1==cat){ // a test for the particular gene if it belongs to a particular order
                for (int j=0; j<cl[0].length; j++){ // it scans again the gene in order to store the percentages of consistency
                    int reg=1;
                    while (j+1<cl[0].length && cl[i][j]==cl[i][j+1]){
                        reg++;
                        j++;
                    }
                    float perc1=0;
                    if (cl[i][j]==label1){
                        perc1=(float)reg/(float)n;
                    }
                    if(perc1>pvalues[0][pvalues[0].length-cat]){
                        v.add(String.valueOf(i)+"\t"+String.valueOf(cl[i][j])+"\t"+String.valueOf(perc1)+"\t"+String.valueOf(j-reg+1)+"\t"+String.valueOf(j)+"\t"+String.valueOf(val[i][j-reg+1])+"\t"+String.valueOf(val[i][j])+"\t"+String.valueOf(cat));
                        // it stores information in the vector v
                    }
                }
            }
            if (succ2==cat){
                for (int j=0; j<cl[0].length; j++){
                    int reg=1;
                    while (j+1<cl[0].length && cl[i][j]==cl[i][j+1]){
                        reg++;
                        j++;
                    }
                    float perc2=0;
                    if (cl[i][j]==label2){
                        perc2=(float)reg/(float)p;
                    }
                    if(perc2>pvalues[1][pvalues[0].length-cat]){
                        v.add(String.valueOf(i)+"\t"+String.valueOf(cl[i][j])+"\t"+String.valueOf(perc2)+"\t"+String.valueOf(j-reg+1)+"\t"+String.valueOf(j)+"\t"+String.valueOf(val[i][j-reg+1])+"\t"+String.valueOf(val[i][j])+"\t"+String.valueOf(cat));
                    }
                }
            }
        }
        if (v.size()>0){
            consistentmatrix=e.VectorTo2DArray(v);
        } else{
            consistentmatrix=new float[1][1];
            consistentmatrix[0][0]=-1;
        }
        return consistentmatrix; // a matrix with the consistent regions, the columns are
        // index of gene, class, percentage of consistency, initial point of region, final point of regions, expression value of the initial point, expression value of the final point, category (order)
    }
    
    /**
     * returns a matrix with all the classifierrs from order 1 until order cat, and an array with the corresponding lengths for each order
     * @param cat
     * @return
     */
    public Object[]  AllCatClassifiers(int cat){
        Object[] o=new Object[2];
        essential e=new essential();
        int[]  size=new int[cat];
        float[][] totmatrix;
        int nofclassifiers=0;
        int w=0;
        Vector v=new Vector();
        for (int i=cat; i>0; i--){
            float[][] CatMat=CatClassifiers(cat-i+1);
            if (CatMat[0][0]!=-1){ // this is the test. if it is true it means that the matrix contains more than zero elements.
                w=CatMat[0].length;
                int wl=CatMat.length;
                size[cat-i]=CatMat.length;
                System.out.println("There are "+wl+" genes for regions: "+(cat-i+1));
                for (int j=0; j<CatMat.length; j++){
                    v.add(CatMat[j]);
                }
            }
        }
        
        if (v.size()>0){
            totmatrix=new float[v.size()][w];
            for(int i=0; i<totmatrix.length; i++){
                totmatrix[i]=(float[])v.elementAt(i);
            }
        } else{
            totmatrix=new float[1][1];
        }
        System.out.println("Total Number of Genes-Classifiers :  "+totmatrix.length);
        o[0]=totmatrix;
        o[1]=size;
        return o;
    }
    
    
    /**
     * This method produces a matrix which will be used later for the determination of the distance between
     * the samples. The columns represent the regions, and the lines the samples. A cell has a value of 0 if
     * a region does not vote for it, and 1 otherwise.
     * @param cat
     * @param choose
     * @return
     */
    public float[][] PreDistanceMatrix(int cat, int choose){
        essential e=new essential();
        float[][] classifiers=(float[][])(AllCatClassifiers(cat)[0]);
        //e.PrintArray(classifiers);
        if (choose!=0){
            classifiers=e.TakePartialMatrix(classifiers,classifiers[0].length-1,choose);
        }
        
        float[][] predistance=new float[test[0].length][classifiers.length];
        //float[][] predistance=new float[test[0].length+2][classifiers.length];
        if (classifiers.length>1){
            for (int i=0; i<test[0].length; i++){
                for (int j=0; j<predistance[0].length; j++){
                    if(test[(int)classifiers[j][0]][i]>=classifiers[j][5] && test[(int)classifiers[j][0]][i]<=classifiers[j][6]){
                        predistance[i][j]=1;
                    } else{
                        predistance[i][j]=0;
                    }
                }
                
            }
            
            for (int i=test[0].length; i<predistance.length; i++){
                for(int j=0; j<predistance[0].length; j++){
                    if(classifiers[j][1]==label1){
                        predistance[i][j]=1;
                    } else predistance[i][j]=0;
                }
                i++;
                for (int j=0; j<predistance[0].length; j++){
                    if(classifiers[j][1]==label2){
                        predistance[i][j]=1;
                    } else predistance[i][j]=0;
                }
            }
        }
        //e.PrintArray(predistance);
        return predistance;
    }
    
    public Vector Total_PreDistanceMatrix(int cat){
        Vector v=new Vector();
        int length=0;
        
        for(int i=1; i<=cat; i++){
            float[][] predistance=PreDistanceMatrix(cat,i);
            
            
            for(int rr=0; rr<predistance[0].length; rr++){
                float[] clm=new float[predistance.length];
                length=clm.length;
                for(int r=0; r<clm.length; r++) {
                    clm[r]=predistance[r][rr];
                    //System.out.print(clm[r]+"\t");
                }
                //System.out.println();
                v.add(clm);
                float[] ar = (float[] )v.elementAt(v.size()-1);
                for (int j=0; j<ar.length; j++) System.out.print(ar[j]+"*\t");
                System.out.println();
            }
        }
       // System.out.println("\n\n\n\n****************************************\n\n\n");
        System.out.println("total genes for printing: "+v.size()+"\n"+"length: "+length+"\n");
        
        for (int i=0; i<v.size(); i++){
            for (int j=0; j<length; j++){
                System.out.print(((float[])v.elementAt(i))[j]+"*\t");
            }
            System.out.println();
        }
        return v;
    }
    
    /**
     * It is a pre distance matrix (see Predistance method), but each the columns represent the genes and not the regions
     * if at least one region of the gene votes, then the whole gene vote.
     * It is used for the first classification step.
     * @param cat
     * @param choose
     * @return
     */
    public float[][] GenePreDistanceMatrix(int cat, int choose){
        
        essential e=new essential();
        float[][] genepredistance;
        float[][] gp=PreDistanceMatrix(cat, choose);
        
        if(gp[0].length>1){
            if (choose!=0 && choose!=1){
                genepredistance=new float[gp.length][(int)gp[0].length/(int)choose];
                for (int i=0; i<genepredistance.length; i++){
                    for (int j=0; j<genepredistance[0].length; j++){
                        float partsum=0;
                        for (int jj=0; jj<choose; jj++){
                            partsum+=gp[i][j*choose+jj];
                        }
                        genepredistance[i][j]=partsum;
                    }
                }
            } else genepredistance=gp;
            
            for(int i=0; i<genepredistance.length;i++){
                int sum=0;
                for(int j=0; j<genepredistance[0].length; j++){
                    sum+=genepredistance[i][j];
                }
                System.out.println("sample "+i+"\t: "+"is classified by : "+sum+" genes\n");
            }
            
            int count=0;
            for(int j=0; j<genepredistance[0].length; j++){
                for (int i=0; i<genepredistance.length; i++){
                    if(genepredistance[i][j]!=0) {
                        count ++;
                        break;
                    }
                }
            }
            System.out.println("\n"+"** "+count+" genes were used totally **");
            return genepredistance;
        } else return gp;
    }
    /**
     * It unifies  the predistance matrices for all the orders.
     * @param cat
     * @param choose
     * @param choose_min
     * @return
     */
    public Object[] UnifiedPredistance(int cat,int choose, int choose_min){
        essential e=new essential();
        Object[] ret=new Object[2];
        float[][] tot_preD;
        float sum[];
        if(choose!=0){
            float[][] part_preD=GenePreDistanceMatrix(cat,choose_min);
            tot_preD=part_preD;
            for (int i=2; i<=choose; i++){
                
                part_preD=GenePreDistanceMatrix(cat,i);
                if(part_preD[0].length>1){
                    tot_preD=e.MergeArrays(tot_preD,part_preD);
                }
                
            }
        }
        
        else tot_preD=GenePreDistanceMatrix(cat,0);
        
        sum=new float[tot_preD.length];
        for(int i=0; i<sum.length; i++){
            for(int j=0; j<tot_preD[0].length; j++){
                sum[i]+=tot_preD[i][j];
            }
        }
        ret[0]=tot_preD;
        ret[1]=sum;
        return ret;
    }
    
    
    /**
     * the distance matrix is computed from the unified predistance matrix
     *
     * @param cat, the maximum order
     * @param choose, a particular order
     * @param choose_min. the minimum order
     * @return
     */
    public float[][] DistanceMatrix(int cat, int choose, int choose_min){
        essential e=new essential();
        Object[] ob=UnifiedPredistance(cat,choose,choose_min);
        float[][] predistance=(float[][])(ob[0]);
        float[] sum=(float[])ob[1];
        float[][] dist=new float[predistance.length][predistance.length];
        for(int i=0; i<predistance.length; i++){
            for(int ii=0; ii<predistance.length; ii++){
                for (int j=0; j<predistance[0].length; j++){
                    dist[i][ii]+=Math.abs(predistance[i][j]-predistance[ii][j]);
                }
            }
        }
        return dist;
    }
    
    /**
     *
     * @return the test set
     */
    public float[][] test(){
        return test;
    }
    
    /**
     * transforms the distance matrix from float to double
     * @param cat
     * @param choose
     * @param choose_min
     * @return
     */
    public double[][] DistanceMatrix_d(int cat, int choose, int choose_min){
        essential e=new essential();
        //ConsistentRegions cr=new ConsistentRegions(Train, Label, Test, cat, repl, (double)((double)perc/(double)100));
        float[][] d_float=DistanceMatrix(cat,choose,choose_min);
        double[][] dist=new double[d_float.length][d_float[0].length];
        for (int i=0; i<d_float.length; i++){
            for (int j=0; j<d_float[0].length; j++){
                dist[i][j]=(double)(d_float[i][j]);
            }
        }
        return dist;
        
        
    }
    
    
    /**
     *         //************************ SUBGRPOUPS SECTION *********************
     * return a part of the matrix with the regions that constitute the classifier
     * it returns only the classifiers that belong to order "choose"
     * @param cat
     * @param choose
     * @return
     */
    public float[][] RegClass(int cat,int choose){
        essential e=new essential();
        float[][] classifiers=(float[][])(AllCatClassifiers(cat)[0]);
        if (choose!=0){
            classifiers=e.TakePartialMatrix(classifiers,classifiers[0].length-1,choose);
        }
        return classifiers;
    }
    
    /**
     * returns the predistance matrix
     * @param cat, the maximum number of orders
     * @param test_set, the test data set
     * @param choose, the current order
     * @return
     */
    public float[][] PreDistanceMatrix(int cat, float[][] test_set, int choose){
        essential e=new essential();
        float[][] classifiers=(float[][])(AllCatClassifiers(cat)[0]);
        if (choose!=0){
            classifiers=e.TakePartialMatrix(classifiers,classifiers[0].length-1,choose);
        }
        float[][] predistance=new float[test_set[0].length][classifiers.length];
        
        for (int i=0; i<test_set[0].length; i++){
            for (int j=0; j<predistance[0].length; j++){
                if (test_set[(int)classifiers[j][0]][i]>=classifiers[j][5] && test_set[(int)classifiers[j][0]][i]<=classifiers[j][6]){
                    predistance[i][j]=1;
                } else{
                    predistance[i][j]=0;
                }
            }
        }
        return predistance;
    }
    
    /**
     * a distance method that compute the distance of samples
     * @param cat
     * @param test_set
     * @param choose
     * @return
     */
    public double[][] DistanceMatrix(int cat, float[][] test_set, int choose){
        essential e=new essential();
        
        float[][] predistance=PreDistanceMatrix(cat,test_set,choose);
        
        double[][] dist=new double[predistance.length][predistance.length];
        for(int i=0; i<predistance.length; i++){
            for(int ii=0; ii<predistance.length; ii++){
                for (int j=0; j<predistance[0].length; j++){
                    dist[i][ii]+=Math.abs(predistance[i][j]-predistance[ii][j]);
                }
            }
        }
        return dist;
    }
    
    public void PrintGenes(String GenesNamesFile, int cat, String outfile){
        
        Vector totalpredistance=Total_PreDistanceMatrix(cat);
        
        System.out.println("VECTOR SIZE: "+totalpredistance.size());
        
        float[][] classifiers=(float[][])(AllCatClassifiers(cat)[0]);
        DataInputStream dis = null;
        String record = null;
        Vector v=new Vector();
        // float [][] element;
        try {
            File f = new File(GenesNamesFile);//C:\home\Pavlos\Published_Datasets\Results\Lawrence
            FileInputStream fis = new FileInputStream(f);
            BufferedInputStream bis = new BufferedInputStream(fis);
            dis = new DataInputStream(bis);
            
            while ( (record=dis.readLine()) != null ) {
                v.add(record);
                //  System.out.println(record);
            }
            
            
            dis.close();
        } catch (IOException e) {
            //catch io errors from FileInputStream or readLine()
            System.out.println("Uh oh, got an IOException error!" + e.getMessage());
        }
        File outf=new File(outfile);
        try{
            FileWriter out=new FileWriter(outf);
            for(int i=0; i<classifiers.length; i++){
                out.write(classifiers[i][0]+"\t"+classifiers[i][classifiers[0].length-1]+"\t"+classifiers[i][2]+"\t"+v.elementAt((int)(classifiers[i][0]))+"\t");
                float[] element=(float[])totalpredistance.elementAt(i);
                for(int j=0; j<element.length; j++){
                    //System.out.print(((float[])totalpredistance.elementAt(i))[j]+":"+element[j]+"\t");
                    if(element[j]!=0){
                        int ind=j+1;
                        out.write(ind+"\t");
                    }
                    else out.write("-\t");
                }
                System.out.println();
                out.write("\n");
                //System.out.println(classifiers[i][0]+"\t"+classifiers[i][classifiers[0].length-1]+"\t"+classifiers[i][2]+"\t"+"\t"+v.elementAt((int)(classifiers[i][0])));
            }
            out.close();
        } catch(IOException e){
            System.out.println("sfalma me to output twn gonidiwn"+e.getMessage());
            
        }
    }
    
    /**
     * in this method the trees with the subgroups are produced
     *
     * @param cat, the maximum order
     * @param perc, the percentage of significance for the estimation of a significant region
     * @param repl, the number of replications
     * @param Train, the training dataset
     * @param Label, the path to the file of lables
     * @param Test, the path for the test set
     * @param choose. the current order
     * @param choose_sub, the order which will be used for the construction of the subgroups
     * @param choose_min, the minimum order that will be used
     * @param exclude, a parameter that defines if there will be LOOCV and if yes which columns are excluded
     */
    public void Subgroups(int cat, int perc, String Train, String Label,
            String Test,int choose, int choose_sub, int choose_min, int exclude,
            double similarity, double difference, String GenesNames,
            String OutputNames, String Results, String SubgroupsResults, String LOOCV_Results, boolean trees){
        
        
        UPGMA upgma=new UPGMA(); // a upgma object which will be used for the construction of a UPGMA tree
        // the code is from P. Sestoft, www.dina.kvl.dk/~sestoft/bsa.html
        
        if (exclude<0){ // Here is a normal classification with a test set, if exclude >=0 then LOOCV
            
            
            ConsistentRegions cr=new ConsistentRegions(Train, Label, Test, cat, (double)((double)perc/(double)100000), exclude);
            essential e=new essential();
            double[][] ds=cr.DistanceMatrix_d(cat,choose,choose_min);
            
            cr.PrintGenes(GenesNames,cat,OutputNames+"GenesNames.txt");
            e.MEGAFile(Results+".meg",ds);
            
            float[][] cl=cr.RegClass(cat,choose_sub);
            int[][] classification=upgma.classification(ds);
            new TreeFrame("UPGMA tree " +
                    "# "+exclude, upgma.getRoot());
            
            
            NJ nj=new NJ(ds); // a NJ object for the construction of a Neighbor-joining tree
            // the code is from P. Sestoft, www.dina.kvl.dk/~sestoft/bsa.html
            new TreeFrame("NJ Tree # "+exclude,nj.getRoot()); // the code is from P. Sestoft, www.dina.kvl.dk/~sestoft/bsa.html
            int columns=0;
            
            // construction of a new test set that is comprised of the samples that predicted to belong to the first class
            for(int i=0; i<classification[0].length; i++){
                if (classification[0][i]!=0){
                    columns++;
                }
            }
            
            float[][] test1=new float[cr.test.length][columns];
            classification1=new int[columns];
            int jj=0;
            for (int i=0; i<classification[0].length; i++){
                if (classification[0][i]!=0){
                    classification1[jj]=classification[0][i]-1;
                    jj++;
                }
            }
            for (int i=0; i<test1.length; i++){
                for (int j=0; j<test1[0].length; j++){
                    test1[i][j]=cr.test[i][classification1[j]];
                    
                }
            }
            
            
            //construction of a new test set that is comprised of the samples that predicted to belong to the second class
            
            columns=0;
            for(int i=0; i<classification[0].length; i++){
                if (classification[1][i]!=0){
                    columns++;
                }
            }
            float[][] test2=new float[cr.test.length][columns];
            classification2=new int[columns];
            jj=0;
            for (int i=0; i<classification[0].length; i++){
                if (classification[1][i]!=0){
                    classification2[jj]=classification[1][i]-1;
                    jj++;
                }
            }
            for (int i=0; i<test2.length; i++){
                for (int j=0; j<test2[0].length; j++){
                    test2[i][j]=cr.test[i][classification2[j]];
                    
                }
            }
            
            
                /*the trees of possible subgroups are constructed. Two regions of different genes
                 * belong to the same cluster if they vote for more than a (e.g. 0.5) common samples
                 * With each one of the other regions of the gene this percentage must be lower than b (e.g. 0.25)
                 * See supplementary info
                 */
            
            String path=SubgroupsResults;
            File f=new File(SubgroupsResults+"_Cluster.txt");
            try{
                FileWriter fw=new FileWriter(f);
                Vector[] vi=cr.Clusters(cat,test1,choose_sub,similarity,difference);
                
                for (int i=0; i<vi[0].size(); i++){
                    double dist[][]=dis_mat((float[][])vi[0].elementAt(i));
                    //System.out.println(dist.length+"\t"+classification1.length);
                    e.MEGAFile(path+"CLASS 1 - Tree # "+i+".meg",dist,classification1);
                    
                    if(trees==true){
                        UPGMA up_tree=new UPGMA(dist,classification1);
                        new TreeFrame("CLASS 1 - UPGMA Tree # :"+i, up_tree.getRoot());
                    }
                    
                    int[] lab=(int[])vi[1].elementAt(i);
                    fw.write(" CLASS 1. Genes for Tree "+i+" are : ");
                    for (int j=0; j<lab.length; j++){
                        fw.write((int)cl[lab[j]][0]+"\t");
                        j++;
                    }
                    fw.write("\n");
                }
                
                
                Vector[] vi2=cr.Clusters(cat,test2,choose_sub,similarity,difference);
                
                for (int i=0; i<vi2[0].size(); i++){
                    double dist[][]=dis_mat((float[][])vi2[0].elementAt(i));
                    e.MEGAFile(path+"CLASS 2 - Tree # "+i+".meg",dist,classification2);
                    if (trees==true){
                        UPGMA up_tree=new UPGMA(dist,classification2);
                        new TreeFrame("CLASS 2 - UPGMA Tree # :"+i, up_tree.getRoot());
                    }
                    int[] lab=(int[])vi2[1].elementAt(i);
                    fw.write(" CLASS 2. Genes of cluster "+i+" are : ");
                    for (int j=0; j<lab.length; j++){
                        fw.write((int)cl[lab[j]][0]+"\t");
                        j++;
                    }
                    fw.write("\n");
                }
                
                fw.close();
            } catch (IOException ex){
                System.out.println("lathos "+ex.getMessage());
            }
            
            System.out.println("******TELOS*******");
            
            
            // construction of the total trees for the subgroups, using all the classifier-regions from one particular orders
            
            double[][] ds1=cr.DistanceMatrix(cat,test1,choose_sub);
            double[][] ds2=cr.DistanceMatrix(cat,test2,choose_sub);
            
            NJ up1 = new NJ(ds1,classification1);
            new TreeFrame("NJ Tree * CLASS 1 * All Genes from order "+choose_sub, up1.getRoot());
            
            UPGMA up1a=new UPGMA(ds1,classification1);
            new TreeFrame("UPGMA Tree * CLASS 1 * All Genes from Order "+choose_sub, up1a.getRoot());
            
            e.MEGAFile(path+"Class_1_Order_ "+choose_sub+".meg",ds1,classification1);
            
            NJ up2=new NJ(ds2,classification2);
            new TreeFrame("NJ Tree * CLASS 2 * All Genes from Order "+choose_sub, up2.getRoot());
            
            UPGMA up2a=new UPGMA(ds2,classification2);
            new TreeFrame("UPGMA Tree * CLASS 2 * All Genes from Order "+choose_sub,up2a.getRoot());
            
            e.MEGAFile(path+"Class_2_Order_"+choose_sub+".meg",ds2,classification2);
        } else{ // this is the section for the LOOCV
            essential e=new essential();
            String ResultsPath=LOOCV_Results;
            
            int arx=1;
            for (exclude=0; exclude<=arx; exclude++){
                ConsistentRegions cr=new ConsistentRegions(Train, Label, Test,cat, (double)((double)perc/(double)100000), exclude);
                arx=cr.train[0].length;
                
                //e.PrintArray((float[][])cr.AllCatClassifiers(cat)[0]);
                double[][] ds=cr.DistanceMatrix_d(cat,choose,choose_min);
                float[][] cl=cr.RegClass(cat,choose_sub);
                
                
                int[][] classification=upgma.classification(ds);
                new TreeFrame("UPGMA tree " +
                        "# "+exclude, upgma.getRoot());
                
                e.MEGAFile(ResultsPath+"LOOCV_Tree_"+exclude+".meg",ds);
                
                
            }
        }
                /*
                //System.out.println("***********");
                //System.out.println("mikos"+classification[0].length);
                //System.out.println("mikos"+cr.test.length);
                 
                int columns=0;
                 
                // Dimiourgia tou prwtou test set gia tin prwti class
                for(int i=0; i<classification[0].length; i++){
                        if (classification[0][i]!=0){
                                columns++;
                        }
                }
                //System.out.println("columns "+columns);
                float[][] test1=new float[cr.test.length][columns];
                classification1=new int[columns];
                int jj=0;
                for (int i=0; i<classification[0].length; i++){
                        if (classification[0][i]!=0){
                                classification1[jj]=classification[0][i]-1;
                                jj++;
                        }
                }
                for (int i=0; i<test1.length; i++){
                        for (int j=0; j<test1[0].length; j++){
                                test1[i][j]=cr.test[i][classification1[j]];
                 
                        }
                }
                 
                 
                // Dimiourgia tou test gia tin deuteri class
                columns=0;
                for(int i=0; i<classification[0].length; i++){
                        if (classification[1][i]!=0){
                                columns++;
                        }
                }
                float[][] test2=new float[cr.test.length][columns];
                classification2=new int[columns];
                jj=0;
                for (int i=0; i<classification[0].length; i++){
                        if (classification[1][i]!=0){
                                classification2[jj]=classification[1][i]-1;
                                jj++;
                        }
                }
                for (int i=0; i<test2.length; i++){
                        for (int j=0; j<test2[0].length; j++){
                                test2[i][j]=cr.test[i][classification2[j]];
                 
                        }
                }
                 
                //cr.Clust(cat,test1,choose_sub,0.40,0.25);
                Vector[] vi=cr.Clusters(cat,test1,choose_sub,1.90,0.01);
                 
                for (int i=0; i<vi[0].size(); i++){
                        double dist[][]=dis_mat((float[][])vi[0].elementAt(i));
                        UPGMA up_tree=new UPGMA(dist,classification1);
                        new TreeFrame("Clust - UPGMA Tree # :"+i, up_tree.getRoot());
                        int[] lab=(int[])vi[1].elementAt(i);
                        System.out.print(" CLASS 1. Genes of cluster "+i+" are : ");
                        for (int j=0; j<lab.length; j++){
                                System.out.print(cl[lab[j]][0]+"\t");
                                j++;
                        }
                        System.out.println();
                }
                 
                 
                Vector[] vi2=cr.Clusters(cat,test2,choose_sub,1.90,0.01);
                 
                for (int i=0; i<vi2[0].size(); i++){
                        double dist[][]=dis_mat((float[][])vi2[0].elementAt(i));
                        UPGMA up_tree=new UPGMA(dist,classification2);
                        new TreeFrame("Clust 2 - UPGMA Tree # :"+i, up_tree.getRoot());
                        int[] lab=(int[])vi2[1].elementAt(i);
                        System.out.print(" CLASS 2. Genes of cluster "+i+" are : ");
                        for (int j=0; j<lab.length; j++){
                                System.out.print(cl[lab[j]][0]+"\t");
                                j++;
                        }
                        System.out.println();
                }
                 
                System.out.println("******TELOS*******");
                //System.exit(1);
                 
                double[][] ds1=cr.DistanceMatrix(cat,test1,choose_sub);
                //e.PrintArray(ds1);
                //System.exit(1);
                double[][] ds2=cr.DistanceMatrix(cat,test2,choose_sub);
                 
                NJ up1 = new NJ(ds1,classification1);
            new TreeFrame("NJ_1 tree", up1.getRoot());
                 
            UPGMA up1a=new UPGMA(ds1,classification1);
            new TreeFrame("UPGMA_1 tree", up1a.getRoot());
                 
            NJ up2=new NJ(ds2,classification2);
            new TreeFrame("NJ_2 tree", up2.getRoot());
                 
            UPGMA up2a=new UPGMA(ds2,classification2);
            new TreeFrame("UPGMA_2 tree",up2a.getRoot());
                 */
        //======================TELOS SUB_CLUSTER======================================
    }
    
    
    
    /**
     * BEGINNING OF GENE CLUSTERING for the determination of subgroups of samples
     *
     *
     * @param pred
     * @return
     */
    public double[][] dis_mat(float[][] pred ){
        //======================== GENE CLUSTERING ============================
        double[][] dis=new double[pred.length][pred.length];
        for(int i=0; i<pred.length; i++){
            for(int ii=0; ii<pred.length; ii++){
                for (int j=0; j<pred[0].length; j++){
                    dis[i][ii]+=Math.abs(pred[i][j]-pred[ii][j]);
                }
            }
        }
        return dis;
    }
    
    
    /**
     * scales each cell of an array a in order to calculate the similarities later on
     * @param a
     * @return
     */
    public float[][] scale_array(float[][] a){
        float[][] b=new float[a.length][a[0].length];
        int[] sum=new int[a[0].length];
        for (int j=0; j<a[0].length; j++){
            for(int i=0; i<a.length; i++){
                sum[j]+=a[i][j];
            }
        }
        for (int i=0; i<a[0].length; i++){
            for (int j=0; j<a.length; j++){
                if(sum[i]!=0){
                    b[j][i]=a[j][i]/(float)Math.sqrt(sum[i]);
                }
            }
        }
        return b;
    }
    
    public float[][] Mult_Transpose(float[][] a){
        float[][] b=new float[a[0].length][a.length];
        for(int i=0; i<b.length; i++){
            for (int j=0; j<b[0].length; j++){
                b[i][j]=a[j][i];
            }
        }
        float[][] c=new float[a[0].length][b.length];
        for (int i=0; i<c.length; i++){
            for (int j=0; j<c[0].length; j++){
                for (int z=0; z<b[0].length; z++){
                    c[i][j]+=b[i][z]*a[z][j];
                }
            }
        }
        return c;
        
        
    }
    
    public Vector[] Clusters(int cat, float[][] test_set,int choose, double threshold_sim, double threshold_dif){
        Vector[] vec=new Vector[2];
        essential e=new essential();
        float[][] pred=PreDistanceMatrix(cat,test_set,choose);
        float[][] pdm=scale_array(pred);
        int[][] g=new int[pdm[0].length/choose][pdm[0].length/choose];
        
        
        float[][] a=Mult_Transpose(pdm);
        //e.PrintArray(a);
        int sum[] =new int[g.length];
        for (int i=0; i<a.length; i++){
            for (int j=0; j<a[0].length; j++){
                float[] max=new float[choose];;
                int[] max_col=new int[choose];
                int nmin=0;
                for (int ii=0; ii<choose; ii++){
                    for (int jj=0; jj<choose; jj++){
                        max[ii]=Math.max(max[ii],a[i+ii][j+jj]);
                        
                        if (a[i+ii][j+jj]<=threshold_dif){
                            nmin++;
                        }
                        if (max[ii]==a[i+ii][j+jj]){
                            max_col[ii]=j+jj;
                        }
                    }
                    
                }
                
                Arrays.sort(max_col);
                Arrays.sort(max);
                int eq=0;
                out:
                    for (int ii=0; ii<max_col.length-1; ii++){
                        if(max_col[ii]==max_col[ii+1]){
                            eq++;
                            break out;
                        }
                    }
                    
                    if(eq==0 && max[0]>=threshold_sim && nmin==choose*choose-choose){
                        g[i/choose][j/choose]=1;
                        sum[i/choose]++;
                    }
                    
                    
                    j+=choose-1;
            }
            i+=choose-1;
        }
        //e.PrintArray(g);
        
        Vector v=new Vector();
        Vector v1=new Vector();
        for (int i=0; i<g.length; i++){
            if (sum[i]>1){
                float[][] predist=new float[pred.length][sum[i]*choose];
                int[] lab=new int[sum[i]*choose];
                
                
                for (int ii=0; ii<predist.length; ii++){
                    int jj=0;
                    for (int j=0; j<pred[0].length; j++){
                        if(g[i][j/choose]==1){
                            predist[ii][jj]=pred[ii][j];
                            lab[jj]=j;
                            jj++;
                        }
                    }
                }
                v.add(predist);
                v1.add(lab);
            }
        }
        vec[0]=v;
        vec[1]=v1;
        return vec;
    }
    
    
    
      /*  //================== GENE CLUSTERING ================================
       
        public float[][] scale_array(float[][] a){
                for(int i=0; i<a.length; i++){
                        for (int j=0; j<a[0].length; j++){
       
                        }
                }
        }
       
        public int[][] Clust(int cat, float[][] test_set,int choose, double threshold_sim, double threshold_dif){
                essential e=new essential();
                float[][] pdm=PreDistanceMatrix(cat,test_set,choose);
                int[][] clust=new int[pdm[0].length][pdm[0].length];
       
                int[] nofelements=new int[pdm[0].length];
       
       
       
                for(int j=0; j<pdm[0].length; j++){
                        int jjj=0;
                        System.out.print(j+" *** ");
                        int sum1=0;
                        for (int jj=0; jj<pdm[0].length; jj++){
                                int sum2=0;
                                sum1=0;
                                int com=0;
                                for (int i=0; i<pdm.length; i++){
                                        sum1+=pdm[i][j];
                                        sum2+=pdm[i][jj];
                                        if (pdm[i][j]==pdm[i][jj] && pdm[i][j]*pdm[i][jj]!=0){
                                                com++;
                                        }
                                }
                                int clu=0;
                                if ((sum1+sum2-com)!=0 && (double)com/(double)(sum1+sum2-com)>=threshold_sim){
                                        clu=1;
                                        int pos=(jj)%choose;
                                        int dif=0;
                                        for (int z=1; z<=pos; z++){
                                                int s1=0;
                                                int c1=0;
                                                for (int i=0; i<pdm.length; i++){
                                                        s1+=pdm[i][jj-z];
                                                        if(pdm[i][j]==pdm[i][jj-z] && pdm[i][j]*pdm[i][jj-z]!=0){
                                                                c1++;
                                                        }
                                                }
                                                if ((sum1+s1-c1)!=0 && (double)c1/(double)(sum1+s1-com)<=threshold_dif){
                                                        dif++;
                                                }
                                        }
                                        for (int z=1; z<choose-pos; z++){
                                                int s1=0;
                                                int c1=0;
                                                for (int i=0; i<pdm.length; i++){
                                                        s1+=pdm[i][jj+z];
                                                        if(pdm[i][j]==pdm[i][jj+z] && pdm[i][j]*pdm[i][jj+z]!=0){
                                                                c1++;
                                                        }
                                                }
                                                if ((sum1+s1-c1)!=0 && (double)c1/(double)(sum1+s1-com)<=threshold_dif){
                                                        dif++;
                                                }
                                        }
                                        if(dif==choose-1){
                                                for(int z=1; z<=pos; z++){
                                                        clust[j][jj-z]=1;
                                                        //jjj++;
                                                }
                                                clust[j][jj]=1;
                                                //jjj++;
                                                for (int z=1; z<choose-pos; z++){
                                                        clust[j][jj+z]=1;
                                                        //jjj++;
                                                }
                                                jj=jj+(choose-(jj%choose)-1);
       
                                        }
                                }
       
       
                        } // telos gia to jj
                        e.PrintArray(clust[j]);
       
                        //System.out.println();
                }	//telos gia to j
                for (int j=0 ; j<clust[0].length; j++){
                        for (int i=0; i<clust.length; i++){
                                System.out.println(i);
                                int cnt=0;
                                while (cnt<choose && (clust[i+cnt][j]!=0)){
                                        cnt++;
                                }
                                if (cnt<choose){
                                        int z;
                                        for (z=0; z<choose; z++){
                                                clust[i+z][j]=0;
       
                                        }
                                        i+=z-1;
       
                                }
                                else{
                                        i+=cnt-1;
                                }
                        }
                }
                e.PrintArray(clust);
                for (int i=0; i<clust.length; i++){
                        int sum=0;
                        for (int j=0; j<clust[0].length; j++){
                                sum+=clust[i][j];
       
                        }
                        System.out.println(sum);
                }
                return clust;
       
        }
       
        public Vector preD(int cat, float[][] test_set,int choose, double threshold_sim, double threshold_dif, int clust_sz){
                int[][] clust=Clust(cat,test_set,choose,threshold_sim,threshold_dif);
                int [] sz=new int[clust.length];
                float[][] pdm=PreDistanceMatrix(cat,test_set,choose);
       
                for (int i=0; i<clust.length; i++){
                        for (int j=0; j<clust[0].length; j++){
                                sz[i]+=clust[i][j];
                        }
                }
       
                for (int i=0; i<sz.length; i++){
                        if (sz[i]>clust_sz){
                                float[][] predistance=new float[test_set[0].length][sz[i]];
       
                                        int jj=0;
                                        for (int j=0; j<clust[0].length; j++){
                                                for (int ii=0; ii<pdm.length; ii++){
                                                        if (clust[i][j]!=0){
       
                                                        }
                                                }
                                        }
       
                        }
                }
       
        }*/
        /*
                Vector v=new Vector();
                for(int i=0; i<nofelements.length; i++){
         
                        if (nofelements[i]>=2){
                                int[][] predistance=new int[test_set[0].length][nofelements[i]*2];
                                int j=0;
                                while (clust[i][j]!=0){
                                        int jj=0;
                                        if (clust[i][j]%choose!=0){
                                                for(int ii=0; ii<predistance.length; ii++){
                                                        predistance[ii][jj]=(int)pdm[ii][i-1];
                                                        predistance[ii][jj+1]=(int)pdm[ii][i];
                                                }
                                        }
                                        else{
                                                for (int ii=0; ii<predistance.length; ii++){
                                                        predistance[ii][jj]=(int)pdm[ii][i];
                                                        predistance[ii][jj+1]=(int)pdm[ii][i+1];
                                                }
                                        }
                                        jj+=2;
                                        j++;
                                }
                                v.add(predistance);
                        }
         
                }
         
                e.PrintArray(nofelements);
         
        }
         
         */
    
    
    
    
    
    
    
    public static void main(String[] s){
        essential e=new essential();
        
        //int cat=2;
        //int nofrepl=2500;
        //double percent=0.99;
        int cat=4;
        //int repl=100;
        int perc_init=99000; //max=100000
        int choose=cat;
        int choose_sub=2;
        int choose_min=1;
        int decide=-1;// 1 for cross validation -1 for testing
        boolean trees=false;
        double similarity=0.5;
        double difference=0.25;
        
        String GeneNames=e.DialogFiles("/home/pavlos/datasets", "Path for Gene Names");
        String OutputNames=e.DialogFiles("/home/pavlos/datasets", "Output for Gene Names");
        String Results = e.DialogFiles("/home/pavlos/datasets", "Output for Results");
        String SubgroupResults=e.DialogFiles("/home/pavlos/datasets", "Output for Subgroups");
        String LOOCVResults=null;
        if (decide==1){
            LOOCVResults=e.DialogFiles("/home/pavlos/datasets", "Path for LOOCV Results");
            Results=null;
            SubgroupResults=null;
        } else{
            LOOCVResults=null;
        }
        String Train=e.DialogFiles("C:\\home\\Pavlos\\Published_Datasets\\datasets\\", "Training Set");
        String Label=e.DialogFiles("C:\\home\\pavlos\\published_datasets\\datasets\\", "train labels");
        String Test=e.DialogFiles("C:\\home\\pavlos\\published_datasets\\datasets", "Test Set");
        
        
        ConsistentRegions cc=new ConsistentRegions();
        cc.Subgroups(cat,perc_init,Train,Label,
                Test,choose,choose_sub,choose_min,decide,
                similarity, difference, GeneNames, OutputNames,
                Results, SubgroupResults, LOOCVResults, trees);
        
        
        
    }
    
}
